--[[
	OneShotProspect
	A World of Warcraft AddOn by Alex Schumaker
]]--

OSP = LibStub("AceAddon-3.0"):NewAddon("OneShotProspect", "AceConsole-3.0", "AceEvent-3.0")

local _ 
local useitem
local useability = "Prospecting"
local autolootset


function OSP:OnInitialize()
	local f = CreateFrame("Button", "OSPbutton", nil, "SecureActionButtonTemplate")
	f:SetAttribute("type", "macro")
	f:SetText("Prospect")
	OSP:UpdateMacro()
	OSP:RegisterEvent("PLAYER_ENTERING_WORLD")
	OSP:RegisterEvent("CVAR_UPDATE")
end

function OSP:PLAYER_ENTERING_WORLD()
	if not OSP:CheckForMacro() then
		CreateMacro("OSP", "SPELL_MISC_CONJUREMANAJEWEL", 
			"/run OSP:UpdateMacro() \n/click OSPbutton", nil)
	end
	autolootset = GetCVar("autoLootDefault")
end

function OSP:GetNextOre()
	for i = 0,NUM_BAG_SLOTS do 
		local slots = GetContainerNumSlots(i)
		for j = 0, slots-1 do 
			local k = slots-j
			local _,stack = GetContainerItemInfo(i,k)
			if stack then
				local name,_,_,_,_,_,subclass = GetItemInfo(GetContainerItemID(i,k))
				if name == useitem and stack >= 5 then 
					return i.." "..k
				end 
			end
		end
	end
end

function OSP:UpdateMacro()
	local itemname = GameTooltip:GetItem()
	if itemname then
		local name,_,_,_,_,_,subclass = GetItemInfo(itemname)
		if subclass == "Metal & Stone" then
			useitem = name
			useability = "Prospecting"
		elseif subclass == "Herb" then 
			useitem = name
			useability = "Milling"
		end
	end

	if OSP:GetNextOre() then
		OSPbutton:SetAttribute("macrotext", "/cast "..useability.."\n/use " .. OSP:GetNextOre())
		if autolootset == "0" then
			OSP:RegisterEvent("LOOT_OPENED")
			SetCVar("autoLootDefault", 1)
		end
	end
end

function OSP:LOOT_OPENED()
	SetCVar("autoLootDefault", autolootset)
end

function OSP:CVAR_UPDATE(self, cvar, value)
	if cvar == "AUTO_LOOT_DEFAULT_TEXT" then 
		autolootset = value
	end
end

function OSP:CheckForMacro()
	local global,perChar = GetNumMacros()
	for i = 1, global do 
		local name = GetMacroInfo(i)
		if name == "OSP" then
			return true
		end
	end
	return false
end
















